__author__ = 'Dan'

import os
import _winreg

REG_PATH = r"SOFTWARE\PSAL\GLiMR"

def set_reg(name, value):
    try:
        _winreg.CreateKey(_winreg.HKEY_CURRENT_USER, REG_PATH)
        registry_key = _winreg.OpenKey(_winreg.HKEY_CURRENT_USER, REG_PATH, 0,
                                       _winreg.KEY_WRITE)
        _winreg.SetValueEx(registry_key, name, 0, _winreg.REG_SZ, value)
        _winreg.CloseKey(registry_key)
        return True
    except WindowsError:
        return False

def get_reg(name):
    try:
        registry_key = _winreg.OpenKey(_winreg.HKEY_CURRENT_USER, REG_PATH, 0,
                                       _winreg.KEY_READ)
        value, regtype = _winreg.QueryValueEx(registry_key, name)
        _winreg.CloseKey(registry_key)
        return value
    except WindowsError:
        print 'Was unable to set registry value in HKEY_CURRENT_USER\PSAL\GLiMR'
        return None


here = os.path._getfullpathname('.')

print('\n\nThis only needs to be run once during installation\nfrom the directory containing GLiMR.env.txt')
print('The path to this GLiMR environment file is written to the registry')
# print('\n\n\n\nSetting HKEY_CURRENT_USER\PSAL\GLiMR\GLiMR_path to ' + here)

if set_reg('GLiMR_path', here):       # set new path
    print('GLiMR path read back from CURRENT_USER is ' + get_reg('GLiMR_path'))

    if os.path.exists(os.path.join(here, 'GLiMR.env.txt')):
        print '\n\n\n\nSuccessfully set the registry and found the GLiMR environment file.'
    else:
        print '\nThe GliMR environment file (GLiMR.env.txt) was not found in ' + here
        print '\nPlease put the following three files in the same directory \nand run  Set_GLiMR_path.bat:'
        print '\nGLiMR.env.txt\nGLiMR_set_registry.py\nSet_GLiMR_path.bat'

raw_input('\n\nPress Enter when finished')

# appears to write multiple keys...